// TrigCircle.cpp
// Es ging darum, ob man in einer C++-for-Schleife gleichzeitig
// Variablen eines Typs deklarieren und eines anderen Typs
// initialisieren kann.
// Antwort: nein!

// Java findet benutzte Klassen allein.
// Der C++-Compiler muss die Deklaration sehen,
// entweder per #include oder im Quelltext.
# include <stdio.h>

class Circle {
public:
	static double PI;
};
double Circle::PI = 3.1459;

class Math {
public:
	static double sin(double) { return 0.0; }
	static double cos(double) { return 0.0; }
};

// Hier geht es eigentlich los.
static const int NUMPTS = 500;

class TrigCircle {
	friend class TrigCircleInitializer;
private:
	// Statische Klassenvariablen lassen sich nicht
	// als const-expression initialisieren...
	// static const int NUMPTS;
	static double sines[NUMPTS];
	static double cosines[NUMPTS];

	// C++ erlaubt keine statischen Initializer
	// wir legen daher einen Konstruktor an
	// und erzeugen ein globales, statisches Objekt
	TrigCircle () {
		double x = 0.0, delta_x;
		delta_x = (Circle::PI/2)/(NUMPTS-1);
		int i;

		for (i=0, x=0.0; i<NUMPTS; i++, x+=delta_x) {
			sines[i] = Math::sin(x);
			cosines[i] = Math::cos(x);
		}
		printf("Initialisierung abgeschlossen...\n");
	}

	// ...

};
double TrigCircle::sines[NUMPTS];
double TrigCircle::cosines[NUMPTS];

// dient nur der Initialisierung,
// ausserhalb der Klassenimplementation nicht sichtbar
class TrigCircleInitializer {
	TrigCircle _initializer;
};
static TrigCircleInitializer _initializer;

int main(int argc, char ** argv) {
	return 0;
}
